# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AnalyticsAdmin.V1alpha.Model.GoogleAnalyticsAdminV1alphaAuditUserLink do
  @moduledoc """
  Read-only resource used to summarize a principal's effective roles.

  ## Attributes

  *   `directRoles` (*type:* `list(String.t)`, *default:* `nil`) - Roles directly assigned to this user for this entity. Format: predefinedRoles/viewer Excludes roles that are inherited from an account (if this is for a property), group, or organization admin role.
  *   `effectiveRoles` (*type:* `list(String.t)`, *default:* `nil`) - Union of all permissions a user has at this account or property (includes direct permissions, group-inherited permissions, etc.). Format: predefinedRoles/viewer
  *   `emailAddress` (*type:* `String.t`, *default:* `nil`) - Email address of the linked user
  *   `name` (*type:* `String.t`, *default:* `nil`) - Example format: properties/1234/userLinks/5678
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :directRoles => list(String.t()) | nil,
          :effectiveRoles => list(String.t()) | nil,
          :emailAddress => String.t() | nil,
          :name => String.t() | nil
        }

  field(:directRoles, type: :list)
  field(:effectiveRoles, type: :list)
  field(:emailAddress)
  field(:name)
end

defimpl Poison.Decoder,
  for: GoogleApi.AnalyticsAdmin.V1alpha.Model.GoogleAnalyticsAdminV1alphaAuditUserLink do
  def decode(value, options) do
    GoogleApi.AnalyticsAdmin.V1alpha.Model.GoogleAnalyticsAdminV1alphaAuditUserLink.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.AnalyticsAdmin.V1alpha.Model.GoogleAnalyticsAdminV1alphaAuditUserLink do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
