# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AnalyticsAdmin.V1alpha.Model.GoogleAnalyticsAdminV1alphaWebDataStream do
  @moduledoc """
  A resource message representing a Google Analytics web stream.

  ## Attributes

  *   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. Time when this stream was originally created.
  *   `defaultUri` (*type:* `String.t`, *default:* `nil`) - Immutable. Domain name of the web app being measured, or empty. Example: "http://www.google.com", "https://www.google.com"
  *   `displayName` (*type:* `String.t`, *default:* `nil`) - Required. Human-readable display name for the Data Stream. The max allowed display name length is 255 UTF-16 code units.
  *   `firebaseAppId` (*type:* `String.t`, *default:* `nil`) - Output only. ID of the corresponding web app in Firebase, if any. This ID can change if the web app is deleted and recreated.
  *   `measurementId` (*type:* `String.t`, *default:* `nil`) - Output only. Analytics "Measurement ID", without the "G-" prefix. Example: "G-1A2BCD345E" would just be "1A2BCD345E"
  *   `name` (*type:* `String.t`, *default:* `nil`) - Output only. Resource name of this Data Stream. Format: properties/{property_id}/webDataStreams/{stream_id} Example: "properties/1000/webDataStreams/2000"
  *   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. Time when stream payload fields were last updated.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :createTime => DateTime.t() | nil,
          :defaultUri => String.t() | nil,
          :displayName => String.t() | nil,
          :firebaseAppId => String.t() | nil,
          :measurementId => String.t() | nil,
          :name => String.t() | nil,
          :updateTime => DateTime.t() | nil
        }

  field(:createTime, as: DateTime)
  field(:defaultUri)
  field(:displayName)
  field(:firebaseAppId)
  field(:measurementId)
  field(:name)
  field(:updateTime, as: DateTime)
end

defimpl Poison.Decoder,
  for: GoogleApi.AnalyticsAdmin.V1alpha.Model.GoogleAnalyticsAdminV1alphaWebDataStream do
  def decode(value, options) do
    GoogleApi.AnalyticsAdmin.V1alpha.Model.GoogleAnalyticsAdminV1alphaWebDataStream.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.AnalyticsAdmin.V1alpha.Model.GoogleAnalyticsAdminV1alphaWebDataStream do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
